#ifndef included_capo_api_types_h
#define included_capo_api_types_h
#define VL_API_CAPO_API_VERSION_MAJOR 0
#define VL_API_CAPO_API_VERSION_MINOR 1
#define VL_API_CAPO_API_VERSION_PATCH 0
/* Imported API files */
#include <vnet/ip/ip_types.api_types.h>
#include <vnet/fib/fib_types.api_types.h>
typedef enum __attribute__((packed)) {
    CAPO_IP = 0,
    CAPO_IP_AND_PORT = 1,
    CAPO_NET = 2,
} vl_api_capo_ipset_type_t;
STATIC_ASSERT(sizeof(vl_api_capo_ipset_type_t) == sizeof(u8), "size of API enum capo_ipset_type is wrong");
typedef struct __attribute__ ((packed)) _vl_api_capo_three_tuple {
    vl_api_address_t address;
    u8 l4_proto;
    u16 port;
} vl_api_capo_three_tuple_t;
#define VL_API_CAPO_THREE_TUPLE_IS_CONSTANT_SIZE (1)

typedef union __attribute__ ((packed)) _vl_api_capo_ipset_member_val {
    vl_api_address_t address;
    vl_api_prefix_t prefix;
    vl_api_capo_three_tuple_t tuple;
} vl_api_capo_ipset_member_val_t;
#define VL_API_CAPO_IPSET_MEMBER_VAL_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_ipset_member {
    vl_api_capo_ipset_member_val_t val;
} vl_api_capo_ipset_member_t;
#define VL_API_CAPO_IPSET_MEMBER_IS_CONSTANT_SIZE (1)

typedef enum __attribute__((packed)) {
    CAPO_ALLOW = 0,
    CAPO_DENY = 1,
    CAPO_LOG = 2,
    CAPO_PASS = 3,
} vl_api_capo_rule_action_t;
STATIC_ASSERT(sizeof(vl_api_capo_rule_action_t) == sizeof(u8), "size of API enum capo_rule_action is wrong");
typedef enum __attribute__((packed)) {
    CAPO_CIDR = 0,
    CAPO_PORT_RANGE = 1,
    CAPO_PORT_IP_SET = 2,
    CAPO_IP_SET = 3,
} vl_api_capo_entry_type_t;
STATIC_ASSERT(sizeof(vl_api_capo_entry_type_t) == sizeof(u8), "size of API enum capo_entry_type is wrong");
typedef struct __attribute__ ((packed)) _vl_api_capo_port_range {
    u16 start;
    u16 end;
} vl_api_capo_port_range_t;
#define VL_API_CAPO_PORT_RANGE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_entry_set_id {
    u32 set_id;
} vl_api_capo_entry_set_id_t;
#define VL_API_CAPO_ENTRY_SET_ID_IS_CONSTANT_SIZE (1)

typedef union __attribute__ ((packed)) _vl_api_capo_entry_data {
    vl_api_prefix_t cidr;
    vl_api_capo_port_range_t port_range;
    vl_api_capo_entry_set_id_t set_id;
} vl_api_capo_entry_data_t;
#define VL_API_CAPO_ENTRY_DATA_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_rule_entry {
    bool is_src;
    bool is_not;
    vl_api_capo_entry_type_t type;
    vl_api_capo_entry_data_t data;
} vl_api_capo_rule_entry_t;
#define VL_API_CAPO_RULE_ENTRY_IS_CONSTANT_SIZE (1)

typedef enum __attribute__((packed)) {
    CAPO_RULE_FILTER_NONE_TYPE = 0,
    CAPO_RULE_FILTER_ICMP_TYPE = 1,
    CAPO_RULE_FILTER_ICMP_CODE = 2,
    CAPO_RULE_FILTER_L4_PROTO = 3,
} vl_api_capo_rule_filter_type_t;
STATIC_ASSERT(sizeof(vl_api_capo_rule_filter_type_t) == sizeof(u8), "size of API enum capo_rule_filter_type is wrong");
typedef struct __attribute__ ((packed)) _vl_api_capo_rule_filter {
    u32 value;
    vl_api_capo_rule_filter_type_t type;
    u8 should_match;
} vl_api_capo_rule_filter_t;
#define VL_API_CAPO_RULE_FILTER_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_rule {
    vl_api_address_family_t af;
    vl_api_capo_rule_action_t action;
    vl_api_capo_rule_filter_t filters[3];
    u32 num_entries;
    vl_api_capo_rule_entry_t matches[0];
} vl_api_capo_rule_t;
#define VL_API_CAPO_RULE_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_capo_policy_item {
    bool is_inbound;
    u32 rule_id;
} vl_api_capo_policy_item_t;
#define VL_API_CAPO_POLICY_ITEM_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_get_version {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_capo_get_version_t;
#define VL_API_CAPO_GET_VERSION_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_get_version_reply {
    u16 _vl_msg_id;
    u32 context;
    u32 major;
    u32 minor;
} vl_api_capo_get_version_reply_t;
#define VL_API_CAPO_GET_VERSION_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_control_ping {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_capo_control_ping_t;
#define VL_API_CAPO_CONTROL_PING_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_control_ping_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 client_index;
    u32 vpe_pid;
} vl_api_capo_control_ping_reply_t;
#define VL_API_CAPO_CONTROL_PING_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_ipset_create {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_capo_ipset_type_t type;
} vl_api_capo_ipset_create_t;
#define VL_API_CAPO_IPSET_CREATE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_ipset_create_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 set_id;
} vl_api_capo_ipset_create_reply_t;
#define VL_API_CAPO_IPSET_CREATE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_ipset_add_del_members {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 set_id;
    bool is_add;
    u32 len;
    vl_api_capo_ipset_member_t members[0];
} vl_api_capo_ipset_add_del_members_t;
#define VL_API_CAPO_IPSET_ADD_DEL_MEMBERS_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_capo_ipset_add_del_members_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_capo_ipset_add_del_members_reply_t;
#define VL_API_CAPO_IPSET_ADD_DEL_MEMBERS_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_ipset_delete {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 set_id;
} vl_api_capo_ipset_delete_t;
#define VL_API_CAPO_IPSET_DELETE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_ipset_delete_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_capo_ipset_delete_reply_t;
#define VL_API_CAPO_IPSET_DELETE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_rule_create {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_capo_rule_t rule;
} vl_api_capo_rule_create_t;
#define VL_API_CAPO_RULE_CREATE_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_capo_rule_update {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 rule_id;
    vl_api_capo_rule_t rule;
} vl_api_capo_rule_update_t;
#define VL_API_CAPO_RULE_UPDATE_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_capo_rule_update_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_capo_rule_update_reply_t;
#define VL_API_CAPO_RULE_UPDATE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_rule_create_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 rule_id;
} vl_api_capo_rule_create_reply_t;
#define VL_API_CAPO_RULE_CREATE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_rule_delete {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 rule_id;
} vl_api_capo_rule_delete_t;
#define VL_API_CAPO_RULE_DELETE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_rule_delete_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_capo_rule_delete_reply_t;
#define VL_API_CAPO_RULE_DELETE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_policy_create {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 num_items;
    vl_api_capo_policy_item_t rules[0];
} vl_api_capo_policy_create_t;
#define VL_API_CAPO_POLICY_CREATE_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_capo_policy_create_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 policy_id;
} vl_api_capo_policy_create_reply_t;
#define VL_API_CAPO_POLICY_CREATE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_policy_update {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 policy_id;
    u32 num_items;
    vl_api_capo_policy_item_t rules[0];
} vl_api_capo_policy_update_t;
#define VL_API_CAPO_POLICY_UPDATE_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_capo_policy_update_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_capo_policy_update_reply_t;
#define VL_API_CAPO_POLICY_UPDATE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_policy_delete {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 policy_id;
} vl_api_capo_policy_delete_t;
#define VL_API_CAPO_POLICY_DELETE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_policy_delete_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_capo_policy_delete_reply_t;
#define VL_API_CAPO_POLICY_DELETE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_capo_configure_policies {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 sw_if_index;
    u32 num_rx_policies;
    u32 num_tx_policies;
    u32 total_ids;
    u8 invert_rx_tx;
    u32 policy_ids[0];
} vl_api_capo_configure_policies_t;
#define VL_API_CAPO_CONFIGURE_POLICIES_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_capo_configure_policies_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_capo_configure_policies_reply_t;
#define VL_API_CAPO_CONFIGURE_POLICIES_REPLY_IS_CONSTANT_SIZE (1)

#define VL_API_CAPO_GET_VERSION_CRC "capo_get_version_51077d14"
#define VL_API_CAPO_GET_VERSION_REPLY_CRC "capo_get_version_reply_9b32cf86"
#define VL_API_CAPO_CONTROL_PING_CRC "capo_control_ping_51077d14"
#define VL_API_CAPO_CONTROL_PING_REPLY_CRC "capo_control_ping_reply_f6b0b8ca"
#define VL_API_CAPO_IPSET_CREATE_CRC "capo_ipset_create_69150c8a"
#define VL_API_CAPO_IPSET_CREATE_REPLY_CRC "capo_ipset_create_reply_6a43f193"
#define VL_API_CAPO_IPSET_ADD_DEL_MEMBERS_CRC "capo_ipset_add_del_members_e7056d10"
#define VL_API_CAPO_IPSET_ADD_DEL_MEMBERS_REPLY_CRC "capo_ipset_add_del_members_reply_e8d4e804"
#define VL_API_CAPO_IPSET_DELETE_CRC "capo_ipset_delete_ceacdbcb"
#define VL_API_CAPO_IPSET_DELETE_REPLY_CRC "capo_ipset_delete_reply_e8d4e804"
#define VL_API_CAPO_RULE_CREATE_CRC "capo_rule_create_0a2d5fd6"
#define VL_API_CAPO_RULE_UPDATE_CRC "capo_rule_update_a0535ee2"
#define VL_API_CAPO_RULE_UPDATE_REPLY_CRC "capo_rule_update_reply_e8d4e804"
#define VL_API_CAPO_RULE_CREATE_REPLY_CRC "capo_rule_create_reply_b48f8052"
#define VL_API_CAPO_RULE_DELETE_CRC "capo_rule_delete_d19bb6be"
#define VL_API_CAPO_RULE_DELETE_REPLY_CRC "capo_rule_delete_reply_e8d4e804"
#define VL_API_CAPO_POLICY_CREATE_CRC "capo_policy_create_f7ed31a8"
#define VL_API_CAPO_POLICY_CREATE_REPLY_CRC "capo_policy_create_reply_90f27405"
#define VL_API_CAPO_POLICY_UPDATE_CRC "capo_policy_update_e2097dd0"
#define VL_API_CAPO_POLICY_UPDATE_REPLY_CRC "capo_policy_update_reply_e8d4e804"
#define VL_API_CAPO_POLICY_DELETE_CRC "capo_policy_delete_ad833868"
#define VL_API_CAPO_POLICY_DELETE_REPLY_CRC "capo_policy_delete_reply_e8d4e804"
#define VL_API_CAPO_CONFIGURE_POLICIES_CRC "capo_configure_policies_743e3c30"
#define VL_API_CAPO_CONFIGURE_POLICIES_REPLY_CRC "capo_configure_policies_reply_e8d4e804"

#endif
