#ifndef included_ippass_api_types_h
#define included_ippass_api_types_h
#define VL_API_IPPASS_API_VERSION_MAJOR 0
#define VL_API_IPPASS_API_VERSION_MINOR 1
#define VL_API_IPPASS_API_VERSION_PATCH 0
/* Imported API files */
#include <vnet/interface_types.api_types.h>
#include <vnet/ip/ip_types.api_types.h>
#include <vnet/fib/fib_types.api_types.h>
typedef enum {
    IN = 0,
    OUT = 1,
} vl_api_traffic_direction_t;
typedef enum {
    UDP = 0,
    TCP = 1,
} vl_api_traffic_protocol_t;
typedef struct __attribute__ ((packed)) _vl_api_ippass_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool enable_disable;
    vl_api_interface_index_t host_if_index;
    vl_api_interface_index_t wan_if_index;
    vl_api_interface_index_t vm_if_index;
    vl_api_interface_index_t rt_if_index;
} vl_api_ippass_enable_disable_t;
#define VL_API_IPPASS_ENABLE_DISABLE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_ippass_enable_disable_reply_t;
#define VL_API_IPPASS_ENABLE_DISABLE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_pppoe_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool enable_disable;
    vl_api_interface_index_t host_if_index;
    vl_api_interface_index_t wan_if_index;
    vl_api_interface_index_t vm_if_index;
} vl_api_ippass_pppoe_enable_disable_t;
#define VL_API_IPPASS_PPPOE_ENABLE_DISABLE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_pppoe_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_ippass_pppoe_enable_disable_reply_t;
#define VL_API_IPPASS_PPPOE_ENABLE_DISABLE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_permit_host {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool enable;
    vl_api_interface_index_t host_if_index;
    bool direct_out;
    u32 dst_port;
    vl_api_address_t ip;
    vl_api_address_t src_ip;
    u32 direction;
    u32 protocol;
} vl_api_ippass_permit_host_t;
#define VL_API_IPPASS_PERMIT_HOST_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_permit_host_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_ippass_permit_host_reply_t;
#define VL_API_IPPASS_PERMIT_HOST_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_if_status {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_interface_index_t host_if_index;
} vl_api_ippass_if_status_t;
#define VL_API_IPPASS_IF_STATUS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_if_status_reply {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    i32 retval;
    vl_api_interface_index_t host_if_index;
    vl_api_interface_index_t wan_if_index;
    vl_api_interface_index_t vm_if_index;
    vl_api_interface_index_t rt_if_index;
    u8 arp_term;
    u8 pppoe_mode;
} vl_api_ippass_if_status_reply_t;
#define VL_API_IPPASS_IF_STATUS_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_arp_term_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool enable_disable;
    vl_api_interface_index_t host_if_index;
} vl_api_ippass_arp_term_enable_disable_t;
#define VL_API_IPPASS_ARP_TERM_ENABLE_DISABLE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_ippass_arp_term_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_ippass_arp_term_enable_disable_reply_t;
#define VL_API_IPPASS_ARP_TERM_ENABLE_DISABLE_REPLY_IS_CONSTANT_SIZE (1)

#define VL_API_IPPASS_ENABLE_DISABLE_CRC "ippass_enable_disable_01bb76c6"
#define VL_API_IPPASS_ENABLE_DISABLE_REPLY_CRC "ippass_enable_disable_reply_e8d4e804"
#define VL_API_IPPASS_PPPOE_ENABLE_DISABLE_CRC "ippass_pppoe_enable_disable_f4887c20"
#define VL_API_IPPASS_PPPOE_ENABLE_DISABLE_REPLY_CRC "ippass_pppoe_enable_disable_reply_e8d4e804"
#define VL_API_IPPASS_PERMIT_HOST_CRC "ippass_permit_host_9a8e4148"
#define VL_API_IPPASS_PERMIT_HOST_REPLY_CRC "ippass_permit_host_reply_e8d4e804"
#define VL_API_IPPASS_IF_STATUS_CRC "ippass_if_status_a7c99e48"
#define VL_API_IPPASS_IF_STATUS_REPLY_CRC "ippass_if_status_reply_0d1ff615"
#define VL_API_IPPASS_ARP_TERM_ENABLE_DISABLE_CRC "ippass_arp_term_enable_disable_6e0da81c"
#define VL_API_IPPASS_ARP_TERM_ENABLE_DISABLE_REPLY_CRC "ippass_arp_term_enable_disable_reply_e8d4e804"

#endif
