#ifndef included_pbl_api_types_h
#define included_pbl_api_types_h
#define VL_API_PBL_API_VERSION_MAJOR 0
#define VL_API_PBL_API_VERSION_MINOR 1
#define VL_API_PBL_API_VERSION_PATCH 0
/* Imported API files */
#include <vnet/ip/ip_types.api_types.h>
#include <vnet/fib/fib_types.api_types.h>
#include <vnet/interface_types.api_types.h>
typedef enum {
    PBL_API_FLAG_EXCLUSIVE = 1,
} vl_api_pbl_client_flags_t;
typedef struct __attribute__ ((packed)) _vl_api_pbl_port_range {
    u16 start;
    u16 end;
    vl_api_ip_proto_t iproto;
} vl_api_pbl_port_range_t;
#define VL_API_PBL_PORT_RANGE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pbl_client {
    u32 id;
    vl_api_address_t addr;
    vl_api_fib_path_t paths;
    u8 flags;
    u32 table_id;
    u32 n_ports;
    vl_api_pbl_port_range_t port_ranges[0];
} vl_api_pbl_client_t;
#define VL_API_PBL_CLIENT_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_pbl_client_update {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_pbl_client_t client;
} vl_api_pbl_client_update_t;
#define VL_API_PBL_CLIENT_UPDATE_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_pbl_client_update_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 id;
} vl_api_pbl_client_update_reply_t;
#define VL_API_PBL_CLIENT_UPDATE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pbl_client_del {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 id;
} vl_api_pbl_client_del_t;
#define VL_API_PBL_CLIENT_DEL_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pbl_client_del_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_pbl_client_del_reply_t;
#define VL_API_PBL_CLIENT_DEL_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pbl_client_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_pbl_client_t client;
} vl_api_pbl_client_details_t;
#define VL_API_PBL_CLIENT_DETAILS_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_pbl_client_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_pbl_client_dump_t;
#define VL_API_PBL_CLIENT_DUMP_IS_CONSTANT_SIZE (1)

#define VL_API_PBL_CLIENT_UPDATE_CRC "pbl_client_update_d83d6e65"
#define VL_API_PBL_CLIENT_UPDATE_REPLY_CRC "pbl_client_update_reply_e2fc8294"
#define VL_API_PBL_CLIENT_DEL_CRC "pbl_client_del_3a91bde5"
#define VL_API_PBL_CLIENT_DEL_REPLY_CRC "pbl_client_del_reply_e8d4e804"
#define VL_API_PBL_CLIENT_DETAILS_CRC "pbl_client_details_14278144"
#define VL_API_PBL_CLIENT_DUMP_CRC "pbl_client_dump_51077d14"

#endif
