#ifndef included_pppox_api_types_h
#define included_pppox_api_types_h
/* Imported API files */
typedef enum {
    PAP = 1,
    CHAP = 2,
} vl_api_pppox_auth_type_t;
typedef struct __attribute__ ((packed)) _vl_api_pppox_set_auth {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 sw_if_index;
    u8 username[64];
    u8 password[64];
    vl_api_pppox_auth_type_t auth_type;
} vl_api_pppox_set_auth_t;
#define VL_API_PPPOX_SET_AUTH_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pppox_set_auth_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_pppox_set_auth_reply_t;
#define VL_API_PPPOX_SET_AUTH_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pppox_set_host {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 pppox_if;
    u32 host_if;
    u16 metric;
    u8 delete;
} vl_api_pppox_set_host_t;
#define VL_API_PPPOX_SET_HOST_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pppox_set_host_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_pppox_set_host_reply_t;
#define VL_API_PPPOX_SET_HOST_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pppox_session_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 sw_if_index;
} vl_api_pppox_session_dump_t;
#define VL_API_PPPOX_SESSION_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_pppox_session_details {
    u16 _vl_msg_id;
    u32 context;
    u32 pppox_sw_if_index;
    u32 host_if_index;
    u8 local_address[16];
    u8 peer_address[16];
    u8 err_code;
    u8 err_reason[128];
    u8 is_ipv6;
} vl_api_pppox_session_details_t;
#define VL_API_PPPOX_SESSION_DETAILS_IS_CONSTANT_SIZE (1)

#define VL_API_PPPOX_SET_AUTH_CRC "pppox_set_auth_87d29a21"
#define VL_API_PPPOX_SET_AUTH_REPLY_CRC "pppox_set_auth_reply_e8d4e804"
#define VL_API_PPPOX_SET_HOST_CRC "pppox_set_host_f4746e55"
#define VL_API_PPPOX_SET_HOST_REPLY_CRC "pppox_set_host_reply_e8d4e804"
#define VL_API_PPPOX_SESSION_DUMP_CRC "pppox_session_dump_529cb13f"
#define VL_API_PPPOX_SESSION_DETAILS_CRC "pppox_session_details_f3544a2d"

#endif
